/* eslint react/jsx-sort-prop-types: 0, react/sort-comp: 0, react/prop-types: 0 */
'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _exenv = require('exenv');

var Option = (function (_React$Component) {
  _inherits(Option, _React$Component);

  function Option() {
    _classCallCheck(this, Option);

    _React$Component.apply(this, arguments);

    this.displayName = 'Option';
  }

  Option.prototype.render = function render() {
    return _react2['default'].createElement(
      'span',
      { className: this.props.className,
        onClick: this.props.click,
        onMouseEnter: this.props.mouseEnter,
        onMouseLeave: this.props.mouseLeave },
      this.props.option.text
    );
  };

  _createClass(Option, null, [{
    key: 'propTypes',
    value: {
      click: _react2['default'].PropTypes.func,
      mouseEnter: _react2['default'].PropTypes.func,
      mouseLeave: _react2['default'].PropTypes.func
    },
    enumerable: true
  }]);

  return Option;
})(_react2['default'].Component);

var Select = (function (_React$Component2) {
  _inherits(Select, _React$Component2);

  function Select(props) {
    _classCallCheck(this, Select);

    _React$Component2.call(this, props);
    this.displayName = 'Select';
    this.state = this.getStateFromValue(this.props.value);
    this.state.isOpen = false;
  }

  Select.prototype.getStateFromValue = function getStateFromValue(value) {
    var _this = this;

    var options = this.props.options;
    var focusedOption = options[0];

    if (!Array.isArray(value)) {
      if (typeof value === 'string') {
        value = value === '' ? [] : [value];
      } else {
        value = value !== undefined && value !== null ? [value] : [];
      }
    }
    var selectedOption = value.map(function (val) {
      if (typeof val === 'string' || typeof val === 'number') {
        var _ref;

        for (var key in options) {
          if (options.hasOwnProperty(key) && options[key] && (options[key][_this.props.valueKey] === val || typeof options[key][_this.props.valueKey] === 'number' && options[key][_this.props.valueKey].toString() === val)) {
            return options[key];
          }
        }
        return (_ref = {}, _defineProperty(_ref, _this.props.valueKey, val), _defineProperty(_ref, _this.props.labelKey, val), _ref);
      } else {
        return val;
      }
    });

    return {
      selectedOption: selectedOption[0],
      focusedOption: focusedOption
    };
  };

  Select.prototype.selectOption = function selectOption(option) {

    // first fire change event
    this.fireChangeEvent(option);

    // then set as the new selected option
    // and close out the dropdown
    this.setState({
      selectedOption: option,
      isOpen: false
    });
    this.props.onClose();
  };

  Select.prototype.focusOption = function focusOption(option) {
    this.setState({
      focusedOption: option
    });
  };

  Select.prototype.unfocusOption = function unfocusOption(op) {
    if (this.state.focusedOption === op) {
      this.setState({
        focusedOption: null
      });
    }
  };

  Select.prototype.fireChangeEvent = function fireChangeEvent(newState) {
    if (newState[this.props.valueKey] !== this.state.selectedOption[this.props.valueKey] && this.props.onChange) {
      this.props.onChange(newState);
    }
  };

  Select.prototype.populateSoD = function populateSoD() {
    var options = this.props.options;

    var ops = options.map(function (op) {
      var focusedValue = this.state.focusedOption ? this.state.focusedOption[this.props.valueKey] : null;
      var defaultValue = this.state.selectedOption[this.props.valueKey] ? this.state.selectedOption[this.props.valueKey] : null;
      var isSelected = defaultValue === op[this.props.valueKey];
      var isFocused = focusedValue === op[this.props.valueKey];
      var optionClass = 'sod_option';
      if (isSelected) {
        optionClass += ' selected';
      }
      if (isFocused) {
        optionClass += ' active';
      }
      var mouseEnter = this.focusOption.bind(this, op);
      var mouseLeave = this.unfocusOption.bind(this, op);
      var mouseDown = this.selectOption.bind(this, op);
      var opKey = 'option-' + op[this.props.valueKey];
      return _react2['default'].createElement(Option, { key: opKey,
        className: optionClass,
        mouseEnter: mouseEnter,
        mouseLeave: mouseLeave,
        click: mouseDown,
        option: op
      });
    }, this);

    return ops;
  };

  Select.prototype.closeSoD = function closeSoD() {
    this.setState({ isOpen: false });
    this.props.onClose();
  };

  Select.prototype.triggerSoD = function triggerSoD(event) {
    this.props.onClick();
    this.props.onActive();
    this.setState({ isOpen: !this.state.isOpen });
  };

  Select.prototype.handleKeyUse = function handleKeyUse(event) {
    switch (event.keyCode) {
      case 8:
        break;

      default:
        break;
    }
  };

  Select.prototype.render = function render() {
    var settingsCycle = this.props.cycle;
    var prefix = this.props.prefix;
    var customID = this.props.customID;
    var sodPrefix = null;
    var optionsWrapper;
    var sodLabel;

    // If there's a prefix defined
    if (prefix) {
      sodPrefix = _react2['default'].createElement(
        'span',
        { className: 'sod_prefix' },
        prefix
      );
    }

    var sodClassName = 'sod_select';

    if (this.state.isOpen) {
      sodClassName += ' focus open';
    }
    if (this.state.selectedOption) {
      sodLabel = this.state.selectedOption[this.props.labelKey];
    }
    optionsWrapper = _react2['default'].createElement(
      'span',
      { className: 'sod_list_wrapper' },
      _react2['default'].createElement(
        'span',
        { className: 'sod_list' },
        this.populateSoD()
      )
    );

    return _react2['default'].createElement(
      'span',
      { className: sodClassName,
        id: customID,
        onClick: this.triggerSoD.bind(this),
        onMouseLeave: this.closeSoD.bind(this),
        onKeyDown: this.handleKeyUse.bind(this)
      },
      _react2['default'].createElement(
        'span',
        { className: 'sod_label' },
        sodPrefix,
        sodLabel
      ),
      optionsWrapper
    );
  };

  _createClass(Select, null, [{
    key: 'propTypes',
    value: {
      customID: _react2['default'].PropTypes.string,
      customClass: _react2['default'].PropTypes.string,
      placeholder: _react2['default'].PropTypes.string,
      placeholderOption: _react2['default'].PropTypes.bool,
      prefix: _react2['default'].PropTypes.string,
      cycle: _react2['default'].PropTypes.bool,
      stripEmpty: _react2['default'].PropTypes.bool,
      links: _react2['default'].PropTypes.bool,
      linksExternal: _react2['default'].PropTypes.bool,
      size: _react2['default'].PropTypes.number,
      tabIndex: _react2['default'].PropTypes.number,
      onChange: _react2['default'].PropTypes.func,
      options: _react2['default'].PropTypes.array,
      labelKey: _react2['default'].PropTypes.string,
      value: _react2['default'].PropTypes.any,
      valueKey: _react2['default'].PropTypes.string
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      customID: null, // String  - '' by default - Adds an ID to the SoD
      customClass: '', // String  - '' by default - Adds a class to the SoD
      placeholder: null, // String  - '' by default - Adds a placeholder that will be shown before a selection has been made
      placeholderOption: false, // Boolean - false by default - Same as above, but it uses the first option in the <select> as a placeholder (and hides it from the list)
      prefix: null, // String  - '' by default - Adds a prefix that always will be shown before the selected value
      cycle: false, // Boolean  - false by default - Should keyboard cycle through options or not?
      stripEmpty: false, // Boolean  - false by default - Should empty <option>'s be stripped from the <select>
      links: false, // Boolean  - false by default - Should the options be treated as links?
      linksExternal: false, // Boolean  - false by default - Should the options be treated as links and open in a new window/tab?
      size: 0, // Integer  - 0 by default - The value set equals the amount of items before scroll is needed
      tabIndex: 0, // integer  - 0 by default
      onActive: function onActive() {},
      onChange: function onChange() {}, // Adds a callback function for when the SoD gets changed
      onClick: function onClick() {},
      onClose: function onClose() {},
      options: null,
      labelKey: 'label',
      value: null,
      valueKey: 'value'
    },
    enumerable: true
  }]);

  return Select;
})(_react2['default'].Component);

exports['default'] = Select;
module.exports = exports['default'];
